Updates release notes for Colorado 3.0
[apex.git] / lib / overcloud-deploy-functions.sh
1 #!/usr/bin/env bash
2 ##############################################################################
3 # Copyright (c) 2015 Tim Rozet (Red Hat), Dan Radez (Red Hat) and others.
4 #
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10
11 ##preping it for deployment and launch the deploy
12 ##params: none
13 function overcloud_deploy {
14   local num_compute_nodes
15   local num_control_nodes
16
17   if [[ "${#deploy_options_array[@]}" -eq 0 || "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
18     if [ "${deploy_options_array['sdn_l3']}" == 'True' ]; then
19       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_l3.yaml"
20     elif [ "${deploy_options_array['sfc']}" == 'True' ]; then
21       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sfc.yaml"
22     elif [ "${deploy_options_array['vpn']}" == 'True' ]; then
23       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sdnvpn.yaml"
24     elif [ "${deploy_options_array['vpp']}" == 'True' ]; then
25       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_fdio.yaml"
26     elif [ "${deploy_options_array['vpn']}" == 'true' ]; then
27       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sdnvpn.yaml"
28     else
29       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight.yaml"
30     fi
31     SDN_IMAGE=opendaylight
32   elif [ "${deploy_options_array['sdn_controller']}" == 'opendaylight-external' ]; then
33     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight-external.yaml"
34     SDN_IMAGE=opendaylight
35   elif [ "${deploy_options_array['sdn_controller']}" == 'onos' ]; then
36     if [ "${deploy_options_array['sfc']}" == 'True' ]; then
37       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos_sfc.yaml"
38     else
39       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos.yaml"
40     fi
41     SDN_IMAGE=onos
42   elif [ "${deploy_options_array['sdn_controller']}" == 'opencontrail' ]; then
43     echo -e "${red}ERROR: OpenContrail is currently unsupported...exiting${reset}"
44     exit 1
45   elif [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
46     echo -e "${blue}INFO: SDN Controller disabled...will deploy nosdn scenario${reset}"
47     if [ "${deploy_options_array['vpp']}" == 'True' ]; then
48       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-networking-vpp.yaml"
49     fi
50     SDN_IMAGE=opendaylight
51   else
52     echo "${red}Invalid sdn_controller: ${deploy_options_array['sdn_controller']}${reset}"
53     echo "${red}Valid choices are opendaylight, opendaylight-external, onos, opencontrail, False, or null${reset}"
54     exit 1
55   fi
56
57
58
59   # Make sure the correct overcloud image is available
60   if [ ! -f $RESOURCES/overcloud-full-${SDN_IMAGE}.qcow2 ]; then
61       echo "${red} $RESOURCES/overcloud-full-${SDN_IMAGE}.qcow2 is required to execute your deployment."
62       echo "Please install the opnfv-apex package to provide this overcloud image for deployment.${reset}"
63       exit 1
64   fi
65
66   echo "Copying overcloud image to Undercloud"
67   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f overcloud-full.qcow2"
68   scp ${SSH_OPTIONS[@]} $RESOURCES/overcloud-full-${SDN_IMAGE}.qcow2 "stack@$UNDERCLOUD":overcloud-full.qcow2
69
70   # Install ovs-dpdk inside the overcloud image if it is enabled.
71   if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' || "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
72     # install dpdk packages before ovs
73     echo -e "${blue}INFO: Enabling kernel modules for dpdk inside overcloud image${reset}"
74
75     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
76       cat << EOF > vfio_pci.modules
77 #!/bin/bash
78 exec /sbin/modprobe vfio_pci >/dev/null 2>&1
79 EOF
80
81       cat << EOF > uio_pci_generic.modules
82 #!/bin/bash
83 exec /sbin/modprobe uio_pci_generic >/dev/null 2>&1
84 EOF
85
86       LIBGUESTFS_BACKEND=direct virt-customize --upload vfio_pci.modules:/etc/sysconfig/modules/ \
87                                                --upload uio_pci_generic.modules:/etc/sysconfig/modules/ \
88                                                --run-command "chmod 0755 /etc/sysconfig/modules/vfio_pci.modules" \
89                                                --run-command "chmod 0755 /etc/sysconfig/modules/uio_pci_generic.modules" \
90                                                -a overcloud-full.qcow2
91
92       if [ "${deploy_options_array['dataplane']}" == 'fdio' ]; then
93         sudo sed -i '/FdioEnabled:/c\  FdioEnabled: true' /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml
94         LIBGUESTFS_BACKEND=direct virt-customize --run-command "cp -f /root/fdio_neutron_l3/namespaces.py /usr/lib/python2.7/site-packages/neutron/agent/l3/" \
95                                                  --run-command "cp -f /root/fdio_neutron_l3/router_info.py /usr/lib/python2.7/site-packages/neutron/agent/l3/" \
96                                                  -a overcloud-full.qcow2
97         if [ "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]; then
98           LIBGUESTFS_BACKEND=direct virt-customize --run-command "cd /root/ && tar zxvf networking-odl.tar.gz" \
99                                                    --run-command "cd /root/networking-odl && git init && pip install -r requirements.txt" \
100                                                    --run-command "cd /root/networking-odl && python setup.py build && python setup.py install" \
101                                                    -a overcloud-full.qcow2
102         fi
103       else
104         sudo sed -i '/NeutronOVSDataPathType:/c\  NeutronOVSDataPathType: netdev' /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml
105         LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/dpdk_rpms/*" \
106                                                  --run-command "sed -i '/RuntimeDirectoryMode=.*/d' /usr/lib/systemd/system/openvswitch-nonetwork.service" \
107                                                  --run-command "printf \"%s\\n\" RuntimeDirectoryMode=0775 Group=qemu UMask=0002 >> /usr/lib/systemd/system/openvswitch-nonetwork.service" \
108                                                  --run-command "sed -i 's/\\(^\\s\\+\\)\\(start_daemon "$OVS_VSWITCHD_PRIORITY"\\)/\\1umask 0002 \\&\\& \\2/' /usr/share/openvswitch/scripts/ovs-ctl" \
109                                                  -a overcloud-full.qcow2
110       fi
111
112 EOI
113
114   elif [ "${deploy_options_array['dataplane']}" != 'ovs' ]; then
115     echo "${red}${deploy_options_array['dataplane']} not supported${reset}"
116     exit 1
117   fi
118
119   if [ "$debug" == 'TRUE' ]; then
120     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "LIBGUESTFS_BACKEND=direct virt-customize -a overcloud-full.qcow2 --root-password password:opnfvapex"
121   fi
122
123   # upgrade ovs into ovs 2.5.90 with NSH function if SFC is enabled
124   if [[ "${deploy_options_array['sfc']}" == 'True' && "${deploy_options_array['dataplane']}" == 'ovs' ]]; then
125     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
126          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_kmod_rpm_name}" \
127                                                   --run-command "yum upgrade -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_rpm_name}" \
128                                                   -a overcloud-full.qcow2
129 EOI
130   fi
131
132   # Set ODL version accordingly
133   if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' && -n "${deploy_options_array['odl_version']}" ]]; then
134     case "${deploy_options_array['odl_version']}" in
135       boron)  odl_version='boron'
136               ;;
137       carbon) odl_version='master'
138               ;;
139       beryllium) odl_version=''
140               ;;
141       *) echo -e "${red}Invalid ODL version ${deploy_options_array['odl_version']}.  Please use 'carbon' or 'boron' values.${reset}"
142          exit 1
143          ;;
144     esac
145
146     if [ -n "$odl_version" ]; then
147       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
148         LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
149                                                  --run-command "yum -y install /root/${odl_version}/*" \
150                                                  -a overcloud-full.qcow2
151 EOI
152     fi
153   fi
154
155   # Add performance deploy options if they have been set
156   if [ ! -z "${deploy_options_array['performance']}" ]; then
157
158     # Remove previous kernel args files per role
159     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f Compute-kernel_params.txt"
160     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f Controller-kernel_params.txt"
161
162     # Push performance options to subscript to modify per-role images as needed
163     for option in "${performance_options[@]}" ; do
164       echo -e "${blue}Setting performance option $option${reset}"
165       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "dataplane=${deploy_options_array['dataplane']} bash build_perf_image.sh $option"
166     done
167
168     # Build IPA kernel option ramdisks
169     ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" <<EOI
170 /bin/cp -f /home/stack/ironic-python-agent.initramfs /root/
171 mkdir -p ipa/
172 pushd ipa
173 gunzip -c ../ironic-python-agent.initramfs | cpio -i
174 if [ ! -f /home/stack/Compute-kernel_params.txt ]; then
175   touch /home/stack/Compute-kernel_params.txt
176   chown stack /home/stack/Compute-kernel_params.txt
177 fi
178 /bin/cp -f /home/stack/Compute-kernel_params.txt tmp/kernel_params.txt
179 echo "Compute params set: "
180 cat tmp/kernel_params.txt
181 /bin/cp -f /root/image.py usr/lib/python2.7/site-packages/ironic_python_agent/extensions/image.py
182 /bin/cp -f /root/image.pyc usr/lib/python2.7/site-packages/ironic_python_agent/extensions/image.pyc
183 find . | cpio -o -H newc | gzip > /home/stack/Compute-ironic-python-agent.initramfs
184 chown stack /home/stack/Compute-ironic-python-agent.initramfs
185 if [ ! -f /home/stack/Controller-kernel_params.txt ]; then
186   touch /home/stack/Controller-kernel_params.txt
187   chown stack /home/stack/Controller-kernel_params.txt
188 fi
189 /bin/cp -f /home/stack/Controller-kernel_params.txt tmp/kernel_params.txt
190 echo "Controller params set: "
191 cat tmp/kernel_params.txt
192 find . | cpio -o -H newc | gzip > /home/stack/Controller-ironic-python-agent.initramfs
193 chown stack /home/stack/Controller-ironic-python-agent.initramfs
194 popd
195 /bin/rm -rf ipa/
196 EOI
197
198     # set NIC heat params and resource registry
199     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
200 if [ -n "${private_network_compute_interface}" ]; then
201   sudo sed -i '/ComputeTenantNIC:/c\  ComputeTenantNIC: '${private_network_compute_interface} /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml
202 fi
203 if [ -n "${private_network_controller_interface}" ]; then
204   sudo sed -i '/ControllerTenantNIC:/c\  ControllerTenantNIC: '${private_network_controller_interface} /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml
205 fi
206 # TODO: PublicNIC is not used today, however, in the future, we'll bind public nic to DPDK as well for certain scenarios. At that time,
207 # we'll need to make sure public network is enabled.
208 if [ -n "${public_network_compute_interface}" ]; then
209   sudo sed -i '/ComputePublicNIC:/c\  ComputePublicNIC: '${public_network_compute_interface} /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml
210 fi
211 if [ -n "${public_network_controller_interface}" ]; then
212   sudo sed -i '/ControllerPublicNIC:/c\  ControllerPublicNIC: '${public_network_controller_interface} /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml
213 fi
214 EOI
215
216     echo -e "${blue}INFO: Including /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml ${reset}"
217     if [ "$debug" == 'TRUE' ]; then
218       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "cat /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml"
219     fi
220     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml"
221   fi
222
223   # make sure ceph is installed
224   DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/storage-environment.yaml"
225
226   # get number of nodes available in inventory
227   num_control_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:control /home/stack/instackenv.json")
228   num_compute_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:compute /home/stack/instackenv.json")
229
230   # check if HA is enabled
231   if [[ "$ha_enabled" == "True" ]]; then
232     if [ "$num_control_nodes" -lt 3 ]; then
233       echo -e "${red}ERROR: Number of control nodes in inventory is less than 3 and HA is enabled: ${num_control_nodes}. Check your inventory file.${reset}"
234       exit 1
235     else
236      DEPLOY_OPTIONS+=" --control-scale ${num_control_nodes}"
237      DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/puppet-pacemaker.yaml"
238      echo -e "${blue}INFO: Number of control nodes set for deployment: ${num_control_nodes}${reset}"
239     fi
240   else
241     if [ "$num_control_nodes" -lt 1 ]; then
242       echo -e "${red}ERROR: Number of control nodes in inventory is less than 1: ${num_control_nodes}. Check your inventory file.${reset}"
243       exit 1
244     fi
245   fi
246
247   if [ "$num_compute_nodes" -le 0 ]; then
248     echo -e "${red}ERROR: Invalid number of compute nodes: ${num_compute_nodes}. Check your inventory file.${reset}"
249     exit 1
250   else
251     echo -e "${blue}INFO: Number of compute nodes set for deployment: ${num_compute_nodes}${reset}"
252     DEPLOY_OPTIONS+=" --compute-scale ${num_compute_nodes}"
253   fi
254
255   if [[ "$net_isolation_enabled" == "TRUE" ]]; then
256      #DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/network-isolation.yaml"
257      DEPLOY_OPTIONS+=" -e network-environment.yaml"
258   fi
259
260   if [[ "$ha_enabled" == "True" ]] || [[ "$net_isolation_enabled" == "TRUE" ]]; then
261      DEPLOY_OPTIONS+=" --ntp-server $ntp_server"
262   fi
263
264   DEPLOY_OPTIONS+=" --control-flavor control --compute-flavor compute"
265   if [[ "$virtual" == "TRUE" ]]; then
266      DEPLOY_OPTIONS+=" -e virtual-environment.yaml"
267   fi
268
269   DEPLOY_OPTIONS+=" -e opnfv-environment.yaml"
270
271   echo -e "${blue}INFO: Deploy options set:\n${DEPLOY_OPTIONS}${reset}"
272
273   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
274 if [ "${deploy_options_array['tacker']}" == 'False' ]; then
275     sed -i '/EnableTacker:/c\  EnableTacker: false' opnfv-environment.yaml
276 fi
277
278 # Create a key for use by nova for live migration
279 echo "Creating nova SSH key for nova resize support"
280 ssh-keygen -f nova_id_rsa -b 1024 -P ""
281 public_key=\'\$(cat nova_id_rsa.pub | cut -d ' ' -f 2)\'
282 sed -i "s#replace_public_key:#key: \$public_key#g" opnfv-environment.yaml
283 python -c 'open("opnfv-environment-new.yaml", "w").write((open("opnfv-environment.yaml").read().replace("replace_private_key:", "key: \"" + "".join(open("nova_id_rsa").readlines()).replace("\\n","\\\n") + "\"")))'
284 mv -f opnfv-environment-new.yaml opnfv-environment.yaml
285
286 source stackrc
287 set -o errexit
288 # Workaround for APEX-207 where sometimes swift proxy is down
289 if ! sudo systemctl status openstack-swift-proxy > /dev/null; then
290   sudo systemctl restart openstack-swift-proxy
291 fi
292 echo "Uploading overcloud glance images"
293 openstack overcloud image upload
294
295 echo "Configuring undercloud and discovering nodes"
296 openstack baremetal import --json instackenv.json
297 openstack baremetal configure boot
298 bash -x set_perf_images.sh ${performance_roles[@]}
299 #if [[ -z "$virtual" ]]; then
300 #  openstack baremetal introspection bulk start
301 #fi
302 echo "Configuring flavors"
303 for flavor in baremetal control compute; do
304   echo -e "${blue}INFO: Updating flavor: \${flavor}${reset}"
305   if openstack flavor list | grep \${flavor}; then
306     openstack flavor delete \${flavor}
307   fi
308   openstack flavor create --id auto --ram 4096 --disk 39 --vcpus 1 \${flavor}
309   if ! openstack flavor list | grep \${flavor}; then
310     echo -e "${red}ERROR: Unable to create flavor \${flavor}${reset}"
311   fi
312 done
313 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" baremetal
314 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="control" control
315 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="compute" compute
316 echo "Configuring nameserver on ctlplane network"
317 dns_server_ext=''
318 for dns_server in ${dns_servers}; do
319   dns_server_ext="\${dns_server_ext} --dns-nameserver \${dns_server}"
320 done
321 neutron subnet-update \$(neutron subnet-list | grep -Ev "id|tenant|external|storage" | grep -v \\\\-\\\\- | awk {'print \$2'}) \${dns_server_ext}
322 sed -i '/CloudDomain:/c\  CloudDomain: '${domain_name} opnfv-environment.yaml
323 echo "Executing overcloud deployment, this should run for an extended period without output."
324 sleep 60 #wait for Hypervisor stats to check-in to nova
325 # save deploy command so it can be used for debugging
326 cat > deploy_command << EOF
327 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
328 EOF
329 EOI
330
331   if [ "$interactive" == "TRUE" ]; then
332     if ! prompt_user "Overcloud Deployment"; then
333       echo -e "${blue}INFO: User requests exit${reset}"
334       exit 0
335     fi
336   fi
337
338   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
339 source stackrc
340 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
341 if ! heat stack-list | grep CREATE_COMPLETE 1>/dev/null; then
342   $(typeset -f debug_stack)
343   debug_stack
344   exit 1
345 fi
346 EOI
347
348   # Configure DPDK
349   if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
350     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI || (echo "DPDK config failed, exiting..."; exit 1)
351 source stackrc
352 set -o errexit
353 for node in \$(nova list | grep novacompute | grep -Eo "[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+"); do
354 echo "Running DPDK test app on \$node"
355 ssh -T ${SSH_OPTIONS[@]} "heat-admin@\$node" <<EOF
356 set -o errexit
357 sudo dpdk_helloworld --no-pci
358 sudo dpdk_nic_bind -s
359 EOF
360 done
361 EOI
362   fi
363
364   if [ "$debug" == 'TRUE' ]; then
365       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
366 source overcloudrc
367 echo "Keystone Endpoint List:"
368 openstack endpoint list
369 echo "Keystone Service List"
370 openstack service list
371 cinder quota-show \$(openstack project list | grep admin | awk {'print \$2'})
372 EOI
373   fi
374 }